# Meta memory space

> Meta memory space - Use the endpoints described below to manage meta memory spaces, which represent
> memory spaces for role-based access control (rbac) purposes.

This Markdown file sits beside the HTML page at the same path (with a `.md` suffix). It summarizes the topic and lists links for tools and LLM context.

Companion generated at `2026-07-27T18:29:27.583363+00:00` (UTC).

## Primary page

- [Meta memory space](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md): Full documentation for this topic (Markdown sidecar).

## Sections on this page

- [Get a list of users, groups by meta memory space ID](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#get-a-list-of-users-groups-by-meta-memory-space-id): In-page section heading.
- [Parameters](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#metamemoryspacessharedroles_list-parameters): In-page section heading.
- [Enumerated Values](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#enumerated-values): In-page section heading.
- [Example responses](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#example-responses): In-page section heading.
- [Responses](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#responses): In-page section heading.
- [Share a meta memory space source by meta memory space ID](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#share-a-meta-memory-space-source-by-meta-memory-space-id): In-page section heading.
- [Body parameter](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#body-parameter): In-page section heading.
- [Parameters](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#metamemoryspacessharedroles_patchmany-parameters): In-page section heading.
- [Responses](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#responses_1): In-page section heading.
- [AccessControlV2](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#tocS_AccessControlV2): In-page section heading.
- [Properties](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#properties): In-page section heading.
- [Enumerated Values](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#enumerated-values_1): In-page section heading.
- [GrantAccessControlWithId](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#tocS_GrantAccessControlWithId): In-page section heading.
- [Properties](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#properties_1): In-page section heading.
- [Enumerated Values](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#enumerated-values_2): In-page section heading.
- [GrantAccessControlWithUsername](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#tocS_GrantAccessControlWithUsername): In-page section heading.
- [Properties](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#properties_2): In-page section heading.
- [Enumerated Values](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#enumerated-values_3): In-page section heading.
- [MetaMemorySpaceSharingUpdateOrRemove](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#tocS_MetaMemorySpaceSharingUpdateOrRemove): In-page section heading.
- [Properties](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#properties_3): In-page section heading.
- [Enumerated Values](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#enumerated-values_4): In-page section heading.
- [SharingListV2Response](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#tocS_SharingListV2Response): In-page section heading.
- [Properties](https://docs.datarobot.com/en/docs/api/reference/public-api/meta_memory_space.html.md#properties_4): In-page section heading.

## Related documentation

- [Developer documentation](https://docs.datarobot.com/en/docs/api/index.html.md): Linked from this page.
- [API reference](https://docs.datarobot.com/en/docs/api/reference/index.html.md): Linked from this page.

## Documentation content

Use the endpoints described below to manage meta memory spaces, which represent memory spaces for role-based access control (rbac) purposes.

## Get a list of users, groups by meta memory space ID

Operation path: `GET /api/v2/metaMemorySpaces/{metaMemorySpaceId}/sharedRoles/`

Authentication requirements: `BearerAuth`

Get a list of users, groups, and organizations with access to this meta memory space.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| id | query | string | false | Only return roles for a user, group or organization with this identifier. |
| offset | query | integer | true | This many results will be skipped |
| limit | query | integer | true | At most this many results are returned |
| name | query | string | false | Only return roles for a user, group or organization with this name. |
| shareRecipientType | query | string | false | The list of access controls for recipients with this type. |
| metaMemorySpaceId | path | string | true | The ID of the meta memory space. |

### Enumerated Values

| Parameter | Value |
| --- | --- |
| shareRecipientType | [user, group, organization, externalApplication] |

### Example responses

> 200 Response

```
{
  "properties": {
    "count": {
      "description": "The number of items returned.",
      "type": "integer"
    },
    "data": {
      "description": "The access control list.",
      "items": {
        "properties": {
          "id": {
            "description": "The identifier of the recipient.",
            "type": "string"
          },
          "name": {
            "description": "The name of the recipient.",
            "type": "string"
          },
          "role": {
            "description": "The role of the recipient on this entity.",
            "enum": [
              "ADMIN",
              "CONSUMER",
              "DATA_SCIENTIST",
              "EDITOR",
              "OBSERVER",
              "OWNER",
              "READ_ONLY",
              "READ_WRITE",
              "USER"
            ],
            "type": "string"
          },
          "scimIdpName": {
            "description": "The scim identity provider name. applicable to user and group recipients.",
            "type": [
              "string",
              "null"
            ],
            "x-versionadded": "v2.46"
          },
          "scimManaged": {
            "description": "Whether the recipient is scim-managed. applicable to user and group recipients.",
            "type": "boolean",
            "x-versionadded": "v2.46"
          },
          "shareRecipientType": {
            "description": "The type of the recipient.",
            "enum": [
              "user",
              "group",
              "organization",
              "externalApplication"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "role",
          "shareRecipientType"
        ],
        "type": "object"
      },
      "maxItems": 1000,
      "type": "array"
    },
    "next": {
      "description": "The url pointing to the next page.",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The url pointing to the previous page.",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items matching the condition.",
      "type": "integer"
    }
  },
  "required": [
    "count",
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object"
}
```

### Responses

| Status | Meaning | Description | Schema |
| --- | --- | --- | --- |
| 200 | OK | none | SharingListV2Response |

## Share a meta memory space source by meta memory space ID

Operation path: `PATCH /api/v2/metaMemorySpaces/{metaMemorySpaceId}/sharedRoles/`

Authentication requirements: `BearerAuth`

Share a meta memory space source with a user, group, or organization.

### Body parameter

```
{
  "properties": {
    "note": {
      "default": "",
      "description": "A note to Go with the project share.",
      "maxLength": 512,
      "type": "string"
    },
    "operation": {
      "description": "Name of the action being taken. the only operation is 'updateroles'.",
      "enum": [
        "updateRoles"
      ],
      "type": "string"
    },
    "roles": {
      "description": "Array of grantaccesscontrol objects., up to maximum 100 objects.",
      "items": {
        "oneOf": [
          {
            "properties": {
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              },
              "username": {
                "description": "Username of the user to update the access role for.",
                "type": "string"
              }
            },
            "required": [
              "role",
              "shareRecipientType",
              "username"
            ],
            "type": "object"
          },
          {
            "properties": {
              "id": {
                "description": "The ID of the recipient.",
                "type": "string"
              },
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              }
            },
            "required": [
              "id",
              "role",
              "shareRecipientType"
            ],
            "type": "object"
          }
        ]
      },
      "maxItems": 100,
      "minItems": 1,
      "type": "array"
    },
    "sendNotification": {
      "default": false,
      "description": "Send a notification?",
      "type": "boolean"
    }
  },
  "required": [
    "operation",
    "roles"
  ],
  "type": "object",
  "x-versionadded": "v2.47"
}
```

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| metaMemorySpaceId | path | string | true | The ID of the meta memory space. |
| body | body | MetaMemorySpaceSharingUpdateOrRemove | false | none |

### Responses

| Status | Meaning | Description | Schema |
| --- | --- | --- | --- |
| 204 | No Content | The roles were updated successfully. | None |
| 422 | Unprocessable Entity | The request was formatted improperly. | None |

# Schemas

## AccessControlV2

```
{
  "properties": {
    "id": {
      "description": "The identifier of the recipient.",
      "type": "string"
    },
    "name": {
      "description": "The name of the recipient.",
      "type": "string"
    },
    "role": {
      "description": "The role of the recipient on this entity.",
      "enum": [
        "ADMIN",
        "CONSUMER",
        "DATA_SCIENTIST",
        "EDITOR",
        "OBSERVER",
        "OWNER",
        "READ_ONLY",
        "READ_WRITE",
        "USER"
      ],
      "type": "string"
    },
    "scimIdpName": {
      "description": "The scim identity provider name. applicable to user and group recipients.",
      "type": [
        "string",
        "null"
      ],
      "x-versionadded": "v2.46"
    },
    "scimManaged": {
      "description": "Whether the recipient is scim-managed. applicable to user and group recipients.",
      "type": "boolean",
      "x-versionadded": "v2.46"
    },
    "shareRecipientType": {
      "description": "The type of the recipient.",
      "enum": [
        "user",
        "group",
        "organization",
        "externalApplication"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "name",
    "role",
    "shareRecipientType"
  ],
  "type": "object"
}
```

### Properties

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| id | string | true |  | The identifier of the recipient. |
| name | string | true |  | The name of the recipient. |
| role | string | true |  | The role of the recipient on this entity. |
| scimIdpName | string,null | false |  | The scim identity provider name. applicable to user and group recipients. |
| scimManaged | boolean | false |  | Whether the recipient is scim-managed. applicable to user and group recipients. |
| shareRecipientType | string | true |  | The type of the recipient. |

### Enumerated Values

| Property | Value |
| --- | --- |
| role | [ADMIN, CONSUMER, DATA_SCIENTIST, EDITOR, OBSERVER, OWNER, READ_ONLY, READ_WRITE, USER] |
| shareRecipientType | [user, group, organization, externalApplication] |

## GrantAccessControlWithId

```
{
  "properties": {
    "id": {
      "description": "The ID of the recipient.",
      "type": "string"
    },
    "role": {
      "description": "The role of the recipient on this entity.",
      "enum": [
        "ADMIN",
        "CONSUMER",
        "DATA_SCIENTIST",
        "EDITOR",
        "NO_ROLE",
        "OBSERVER",
        "OWNER",
        "READ_ONLY",
        "READ_WRITE",
        "USER"
      ],
      "type": "string"
    },
    "shareRecipientType": {
      "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
      "enum": [
        "user",
        "group",
        "organization",
        "externalApplication"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "role",
    "shareRecipientType"
  ],
  "type": "object"
}
```

### Properties

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| id | string | true |  | The ID of the recipient. |
| role | string | true |  | The role of the recipient on this entity. |
| shareRecipientType | string | true |  | Describes the recipient type — one of user, group, organization, or externalapplication. |

### Enumerated Values

| Property | Value |
| --- | --- |
| role | [ADMIN, CONSUMER, DATA_SCIENTIST, EDITOR, NO_ROLE, OBSERVER, OWNER, READ_ONLY, READ_WRITE, USER] |
| shareRecipientType | [user, group, organization, externalApplication] |

## GrantAccessControlWithUsername

```
{
  "properties": {
    "role": {
      "description": "The role of the recipient on this entity.",
      "enum": [
        "ADMIN",
        "CONSUMER",
        "DATA_SCIENTIST",
        "EDITOR",
        "NO_ROLE",
        "OBSERVER",
        "OWNER",
        "READ_ONLY",
        "READ_WRITE",
        "USER"
      ],
      "type": "string"
    },
    "shareRecipientType": {
      "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
      "enum": [
        "user",
        "group",
        "organization",
        "externalApplication"
      ],
      "type": "string"
    },
    "username": {
      "description": "Username of the user to update the access role for.",
      "type": "string"
    }
  },
  "required": [
    "role",
    "shareRecipientType",
    "username"
  ],
  "type": "object"
}
```

### Properties

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| role | string | true |  | The role of the recipient on this entity. |
| shareRecipientType | string | true |  | Describes the recipient type — one of user, group, organization, or externalapplication. |
| username | string | true |  | Username of the user to update the access role for. |

### Enumerated Values

| Property | Value |
| --- | --- |
| role | [ADMIN, CONSUMER, DATA_SCIENTIST, EDITOR, NO_ROLE, OBSERVER, OWNER, READ_ONLY, READ_WRITE, USER] |
| shareRecipientType | [user, group, organization, externalApplication] |

## MetaMemorySpaceSharingUpdateOrRemove

```
{
  "properties": {
    "note": {
      "default": "",
      "description": "A note to Go with the project share.",
      "maxLength": 512,
      "type": "string"
    },
    "operation": {
      "description": "Name of the action being taken. the only operation is 'updateroles'.",
      "enum": [
        "updateRoles"
      ],
      "type": "string"
    },
    "roles": {
      "description": "Array of grantaccesscontrol objects., up to maximum 100 objects.",
      "items": {
        "oneOf": [
          {
            "properties": {
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              },
              "username": {
                "description": "Username of the user to update the access role for.",
                "type": "string"
              }
            },
            "required": [
              "role",
              "shareRecipientType",
              "username"
            ],
            "type": "object"
          },
          {
            "properties": {
              "id": {
                "description": "The ID of the recipient.",
                "type": "string"
              },
              "role": {
                "description": "The role of the recipient on this entity.",
                "enum": [
                  "ADMIN",
                  "CONSUMER",
                  "DATA_SCIENTIST",
                  "EDITOR",
                  "NO_ROLE",
                  "OBSERVER",
                  "OWNER",
                  "READ_ONLY",
                  "READ_WRITE",
                  "USER"
                ],
                "type": "string"
              },
              "shareRecipientType": {
                "description": "Describes the recipient type — one of user, group, organization, or externalapplication.",
                "enum": [
                  "user",
                  "group",
                  "organization",
                  "externalApplication"
                ],
                "type": "string"
              }
            },
            "required": [
              "id",
              "role",
              "shareRecipientType"
            ],
            "type": "object"
          }
        ]
      },
      "maxItems": 100,
      "minItems": 1,
      "type": "array"
    },
    "sendNotification": {
      "default": false,
      "description": "Send a notification?",
      "type": "boolean"
    }
  },
  "required": [
    "operation",
    "roles"
  ],
  "type": "object",
  "x-versionadded": "v2.47"
}
```

### Properties

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| note | string | false | maxLength: 512 | A note to Go with the project share. |
| operation | string | true |  | Name of the action being taken. the only operation is 'updateroles'. |
| roles | [oneOf] | true | maxItems: 100minItems: 1 | Array of grantaccesscontrol objects., up to maximum 100 objects. |

oneOf

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| » anonymous | GrantAccessControlWithUsername | false |  | none |

xor

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| » anonymous | GrantAccessControlWithId | false |  | none |

continued

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| sendNotification | boolean | false |  | Send a notification? |

### Enumerated Values

| Property | Value |
| --- | --- |
| operation | updateRoles |

## SharingListV2Response

```
{
  "properties": {
    "count": {
      "description": "The number of items returned.",
      "type": "integer"
    },
    "data": {
      "description": "The access control list.",
      "items": {
        "properties": {
          "id": {
            "description": "The identifier of the recipient.",
            "type": "string"
          },
          "name": {
            "description": "The name of the recipient.",
            "type": "string"
          },
          "role": {
            "description": "The role of the recipient on this entity.",
            "enum": [
              "ADMIN",
              "CONSUMER",
              "DATA_SCIENTIST",
              "EDITOR",
              "OBSERVER",
              "OWNER",
              "READ_ONLY",
              "READ_WRITE",
              "USER"
            ],
            "type": "string"
          },
          "scimIdpName": {
            "description": "The scim identity provider name. applicable to user and group recipients.",
            "type": [
              "string",
              "null"
            ],
            "x-versionadded": "v2.46"
          },
          "scimManaged": {
            "description": "Whether the recipient is scim-managed. applicable to user and group recipients.",
            "type": "boolean",
            "x-versionadded": "v2.46"
          },
          "shareRecipientType": {
            "description": "The type of the recipient.",
            "enum": [
              "user",
              "group",
              "organization",
              "externalApplication"
            ],
            "type": "string"
          }
        },
        "required": [
          "id",
          "name",
          "role",
          "shareRecipientType"
        ],
        "type": "object"
      },
      "maxItems": 1000,
      "type": "array"
    },
    "next": {
      "description": "The url pointing to the next page.",
      "type": [
        "string",
        "null"
      ]
    },
    "previous": {
      "description": "The url pointing to the previous page.",
      "type": [
        "string",
        "null"
      ]
    },
    "totalCount": {
      "description": "The total number of items matching the condition.",
      "type": "integer"
    }
  },
  "required": [
    "count",
    "data",
    "next",
    "previous",
    "totalCount"
  ],
  "type": "object"
}
```

### Properties

| Name | Type | Required | Restrictions | Description |
| --- | --- | --- | --- | --- |
| count | integer | true |  | The number of items returned. |
| data | [AccessControlV2] | true | maxItems: 1000 | The access control list. |
| next | string,null | true |  | The url pointing to the next page. |
| previous | string,null | true |  | The url pointing to the previous page. |
| totalCount | integer | true |  | The total number of items matching the condition. |
